package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchRequest;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchSystemParams;
import com.docus.server.infrastructure.dao.ISchSystemParamsDao;
import com.docus.server.infrastructure.mapper.SchSystemParamsMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 系统参数表 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-14
 */
@Repository
public class SchSystemParamsDaoImpl extends BaseDaoImpl<SchSystemParamsMapper, SchSystemParams> implements ISchSystemParamsDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchSystemParams findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schSystemParams 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchSystemParams schSystemParams) {
        return super.save(schSystemParams);
    }

    /**
     * 编辑
     *
     * @param schSystemParams 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchSystemParams schSystemParams) {
        return super.updateById(schSystemParams);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<String> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜素
     *
     * @param searchRequest 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchSystemParams> search(SearchRequest searchRequest) {
        //分页
        PageHelper.startPage(searchRequest.getPageNum(), searchRequest.getPageSize());
        LambdaQueryWrapper<SchSystemParams> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchRequest.getBeginTime() != null) {
            query.ge(SchSystemParams::getCreateTime, searchRequest.getBeginTime());
        }
        if (searchRequest.getEndTime() != null) {
            Date endTime = searchRequest.getEndTime();
            query.le(SchSystemParams::getCreateTime, endTime);
        }
        //关键字比较，多个列or
        //if (!StringUtils.isEmpty(searchRequest.getKeyword())) {
        //单个列用like
        //query. like(SchSystemParams::getxxx, searchRequest. getKeyword());
        //多个列用like
        //query. and(sub -> sub.like(SchSystemParams::getxx1, searchRequest. getKeyword())
        // оr(). like(SchSystemParams::getXX2, searchRequest. getKeyword()))
        //);
        //}
        //默认createTime倒序排序
        query.orderByDesc(SchSystemParams::getCreateTime);
        List<SchSystemParams> list = super.find(query);
        return new PageResult<>(list);
    }

}
